package com.capgemini.reports.snecmaobjects.generic;

import com.capgemini.framework.teamcenter.authent.TcSession;
import com.capgemini.framework.teamcenter.object.types.SnecmaObjectTypes;
import com.capgemini.reports.snecmaobjects.visitor.IComponentVisitor;
import com.capgemini.reports.snecmaobjects.visitor.IReceptorVisitor;
import com.teamcenter.soa.client.model.strong.ItemRevision;

/**
 * Class representing a GenericAssembRevision.
 */
public class GenericAssembRevision extends AbstractGenericRevision {
    private static final long serialVersionUID = 74761594141269461L;

    public GenericAssembRevision(final TcSession session, final ItemRevision itemRevision) {
        super(session, itemRevision);
    }

    @Override
    public <T> T accept(final IReceptorVisitor<T> aReceptorVisitor) {
        return aReceptorVisitor.visitReceptor(this);
    }

    @Override
    public <T> T accept(final IComponentVisitor<T> aComponentVisitor) {
        return aComponentVisitor.visitComponent(this);
    }

    @Override
    public boolean isSuperModel() {
        return false;
    }

    @Override
    public String toString() {
        return SnecmaObjectTypes.GENERIC_ASSEMB_REVISION + " " + this.getItemId();
    }

}
